Bug 812347 - High network jitter causes some keystrokes to enter multiple characters instead of one
High network jitter causes some keystrokes to enter multiple characters inste...
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: spice-gtk (Show other bugs)
Unspecified Unspecified
medium Severity low
: beta
: 6.4
Assigned To: Christophe Fergeau
Desktop QE
Depends On:
  Show dependency treegraph
Reported: 2012-04-13 09:19 EDT by David Jaša
Modified: 2013-02-21 03:47 EST (History)
6 users (show)

See Also:
Fixed In Version: spice-gtk-0.14-1.el6
Doc Type: Bug Fix
Doc Text:
Cause: High network jitter causes some keystrokes to enter multiple characters instead of one Consequence: Sometimes multiple characters are entered when the user only wanted to type one character Fix: Improvements to the SPICE protocol to cope better with such situations Result: no unwanted key repetitions
Story Points: ---
Clone Of:
Last Closed: 2013-02-21 03:47:17 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description David Jaša 2012-04-13 09:19:59 EDT
Description of problem:
High network jitter causes some keystrokes to enter multiple characters instead of one.

I suspect that this is caused by sending keystrokes from client "as is" and evaluating what is pressed and how long on qemu side. If this is true, a network jitter can cause that packet carrying key press event is at lowest latency range and packet carrying key release event has highest latency, making qemu see key pressed much longer than user actually presses it.

If my assumptions are good, the solution could be adding timestamps to keyboard events on client and recreate keyboard events in spice server according to them. While this change increases network latency slightly overall, it should improve user productivity by removing errors caused by network latency/jitter that are quite time-consuming to correct (because you never know when your "Delete" key press is recorded as ten...).

Version-Release number of selected component (if applicable):
Spice 0.10.1

How reproducible:

Steps to Reproduce:
Actual results:

Expected results:

Additional info:
Comment 1 David Jaša 2012-04-13 09:25:04 EDT
ping statistics to the host running the VM where I encoutered the problem:

--- <host> ping statistics ---
100 packets transmitted, 98 received, 2% packet loss, time 60467ms
rtt min/avg/max/mdev = 347.170/400.243/515.824/37.753 ms
Comment 2 RHEL Product and Program Management 2012-07-10 02:49:28 EDT
This request was not resolved in time for the current release.
Red Hat invites you to ask your support representative to
propose this request, if still desired, for consideration in
the next release of Red Hat Enterprise Linux.
Comment 3 RHEL Product and Program Management 2012-07-10 22:01:00 EDT
This request was erroneously removed from consideration in Red Hat Enterprise Linux 6.4, which is currently under development.  This request will be evaluated for inclusion in Red Hat Enterprise Linux 6.4.
Comment 4 Marc-Andre Lureau 2012-08-03 16:19:58 EDT
I tried to tackle this problem a while ago.

The problem is that is not solvable with timestamps, since hw keyboard events are not usually assicated with time stamp, and key repeaters are usually implemented in a simpler way that timestamp wouldn't really help either.

once solution is to send a single DOWN_UP event for regular key presses. If we detect that the client typed a short press, we can send this event. If not we send only DOWN, and wait for the release UP (and the key will be repeated).

We had other suggestion and workaround discussed in http://comments.gmane.org/gmane.comp.emulators.spice.devel/8927
Comment 5 Christophe Fergeau 2012-09-18 09:29:14 EDT
Should be addressed by http://cgit.freedesktop.org/spice/spice-gtk/commit/?id=0d5ad7e22d55552ef4be8368dcfbae879fb0b77e and by the commits before this one, so this will get fixed as part of the rebase
Comment 9 errata-xmlrpc 2013-02-21 03:47:17 EST
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.


Note You need to log in before you can comment on or make changes to this bug.